package com.cfp.jcperez.electricost;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

/**
 * Created by Juan Carlos Perez Gonzalez on 04/11/2015.
 * Gestiona el acceso a la BBDD de la aplicacion.
 * En la version 1 solo existira la tabla reintentos para lanzar de nuevo el servicio de busqueda de los
 * horarios mas caros y mas baratos
 */
public class BBDDReintentos extends SQLiteOpenHelper{

    private String TAG="JCP-----";

    public BBDDReintentos(Context context) {
        super(context, "reintentos", null, 1);
    }

    //Creamos la tabla reintentos
    @Override public void onCreate(SQLiteDatabase db) {
        db.execSQL("CREATE TABLE reintentos (" +
                "_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
                "fecha TEXT)");
    }

    @Override public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

    }

    //se encarga de guardar una fecha en la tabla reintentos
    public void guardarReintento(String fecha) {
        SQLiteDatabase db = getWritableDatabase();
        db.execSQL("INSERT INTO reintentos VALUES ( null, "+ fecha+")");
        db.close();
    }

    //borramos todos los reintentos ya que no hay nada pendiente por hacer
    public void borrarReintentos() {
        try {
            SQLiteDatabase db = getWritableDatabase();
            db.close();
            db.execSQL("DELETE FROM reintentos");
        }catch(Exception e){
            Log.d(TAG, "Error "+e.getMessage());
        }
    }

    //obtenemos la fecha de la ultima consulta no completada, con la que lanzaremos los servicios de avisos
    public String getReintento() {
        String fecha = null;
        try{
            SQLiteDatabase db = getReadableDatabase();
            Cursor cursor = db.rawQuery("SELECT fecha FROM  reintentos ", null);

            while (cursor.moveToNext()){
                fecha=cursor.getString(0);
            }
            cursor.close();
            db.close();
        }catch(Exception e){
            Log.d(TAG, "Error "+e.getMessage());
        }finally {
            return fecha;
        }
    }
}
