package com.cfp.jcperez.electricost;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.CalendarView;

/**
 * Created by Juan Carlos Perez Gonzalez on 13/11/2015.
 * Permite al usuario seleccionar un dia para mostrar el precio de la luz para él.
 */
public class CalendarioActivity extends ActionBarActivity {

    String fecha=null;
    @TargetApi(11)
    @Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.calendario);
        CalendarView calendar = (CalendarView) findViewById(R.id.calendarView);
        calendar.setShowWeekNumber(false);
        calendar.setFirstDayOfWeek(2);
        calendar.setOnDateChangeListener(new CalendarView.OnDateChangeListener() {

            @Override
            public void onSelectedDayChange(CalendarView view, int year, int month, int day) {

                String mes;
                if (month < 9) {
                    mes = "0" + (month + 1);
                } else {
                    mes = "" + (month + 1);
                }
                String dia;
                if (day < 10) {
                    dia = "0" + day;
                } else {
                    dia = "" + day;
                }
                fecha = year + "" + mes + dia;
            }
        });


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_calendario, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.menu_volver) {
            this.finish();
        }

        if(id == R.id.menu_Aceptar){
            if(fecha!=null) {
                Intent res = new Intent();
                res.putExtra("Fecha", fecha);
                setResult(Activity.RESULT_OK, res);
            }
            finish();
        }

        return super.onOptionsItemSelected(item);
    }
}
