package com.cfp.jcperez.electricost;

import android.graphics.Color;
import android.widget.BaseAdapter;

import java.util.ArrayList;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by Juan Carlos Perez Gonzalez on 04/11/2015.
 * Se utiliza para gestionar la creación de los elementos de la lista de precios
 */
public class ListAdapter extends BaseAdapter {

    private Context context;
    private ArrayList<String> arrHora;
    private ArrayList<Double> arrPrecio;
    private double precioMin;
    private double precioMax;

    public ListAdapter(Context context, ArrayList<String> arrHora, ArrayList<Double> arrPrecio,double precioMin,double precioMax) {
        this.context = context;
        this.arrHora = arrHora;
        this.arrPrecio = arrPrecio;
        this.precioMin = precioMin;
        this.precioMax = precioMax;
    }

    @Override
    public int getCount() {
        return this.arrPrecio.size();
    }

    @Override
    public Object getItem(int position) {
        return this.arrPrecio.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        View rowView = convertView;
        if (convertView == null) {
            LayoutInflater inflater = (LayoutInflater) context
                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            rowView = inflater.inflate(R.layout.item, parent, false);
        }

        TextView tvHora = (TextView) rowView.findViewById(R.id.tvHora);
        TextView tvPrecio = (TextView) rowView.findViewById(R.id.tvPrecio);

        String strHora=this.arrHora.get(position);
        //Log.d("JCP------",position+"....."+strHora+"......"+precioMin);
        if (strHora.indexOf("-")>-1) {
            tvHora.setText(strHora.substring(0,strHora.indexOf("-"))+ ":00 h");
            String euro = "\u20ac";
            tvPrecio.setText(this.arrPrecio.get(position)+" " +euro +"/kWh");
        }

        ImageView imgTend = (ImageView) rowView.findViewById(R.id.ivTendencia);
        double valNew=this.arrPrecio.get(position);

        //Mostramos una fecha con la tendencia del precio de una hora con respecto a la anterior
        imgTend.setImageResource(0);
        if(position>0) {
            double valAnt=this.arrPrecio.get(position - 1);
            if (valAnt>valNew) {
                imgTend.setImageResource(R.drawable.baja);
            }
            if (valAnt<valNew) {
                imgTend.setImageResource(R.drawable.sube);
            }
        }

        //Ponemos el color por defecto
        tvPrecio.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorList)));
        tvHora.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorList)));
        imgTend.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorList)));

        //Resaltamos en rojo y en verde las filas con los precios maximo y minimo
        if(valNew==precioMin){
            tvPrecio.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorItemBarato)));
            tvHora.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorItemBarato)));
            imgTend.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorItemBarato)));
        }

        if(valNew==precioMax){
            tvPrecio.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorItemCaro)));
            tvHora.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorItemCaro)));
            imgTend.setBackgroundColor(Color.parseColor(context.getString(R.string.backgroundColorItemCaro)));
        }

        return rowView;
    }

}