package com.cfp.jcperez.electricost;

import android.content.Intent;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

/**
 * Created by Juan Carlos Perez Gonzalez on 04/11/2015.
 * La actividad principal de la aplicación
 */

public class MainActivity extends ActionBarActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            lanzarPreferencias(null);
        }
        if (id == R.id.acercaDe) {
            lanzarAcercaDe(null);
        }
        if (id == R.id.menu_salir) {
            finish();
        }

        return super.onOptionsItemSelected(item);
    }

    //muestra la actividad con la información de la app
    public void lanzarAcercaDe(View view){
        Intent i = new Intent (this, AcercaDe.class);
        startActivity(i);
    }

    //muestra las preferencias del usuario
    public void lanzarPreferencias(View view){
        Intent i = new Intent (this, Preferencias.class);
        startActivity(i);
    }

    //inicia la actividad que muestra el listado de los precios de la luz
    public void lanzarConexionRee(View view){
        Intent i = new Intent (this, ObtenerPreciosActivity.class);
        String tipo="";
        if (view.getId() == R.id.BtnTG) {
            i.putExtra("Tipo", "BtnTG");
        }
        if (view.getId() == R.id.BtnTN) {
            i.putExtra("Tipo", "BtnTN");
        }
        if (view.getId() == R.id.BtnCE) {
            i.putExtra("Tipo", "BtnCE");
        }
        startActivity(i);
    }

    //inicia la actividad que muestra nuestra ubicación y los puntos de recarga
    public void lanzarMapaEstaciones(View view){
        Intent i = new Intent (this, MostrarEstacionesActivity.class);
        startActivity(i);
    }

}
