package com.cfp.jcperez.electricost;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
import java.util.ArrayList;

/**
 * Created by Juan Carlos Perez Gonzalez on 10/11/2015.
 * Se encarga de obtener los elementos del archivo xml que contiene el listado de los precios de la luz
 */
public  class ManejadorXMLREE extends DefaultHandler {
    private StringBuilder cadena;

    public ArrayList<String> getArrHora() {
        return arrHora;
    }

    public ArrayList<Double> getArrTarifaNocturna() {
        return arrTarifaNocturna;
    }

    public ArrayList<Double> getArrTarifaGeneral() {
        return arrTarifaGeneral;
    }

    public ArrayList<Double> getArrTarifaVehiculo() {
        return arrTarifaVehiculo;
    }

    private int numRow=0;
    private int numData=0;
    private ArrayList<String> arrHora;
    private ArrayList<Double> arrTarifaNocturna;
    private ArrayList<Double> arrTarifaGeneral;
    private ArrayList<Double> arrTarifaVehiculo;
    @Override
    public void startDocument() throws SAXException {
        cadena = new StringBuilder();
        arrTarifaNocturna = new ArrayList<Double>();
        arrTarifaGeneral = new ArrayList<Double>();
        arrTarifaVehiculo = new ArrayList<Double>();
        arrHora= new ArrayList<String>();
    }
    @Override
    public void startElement(String uri, String nombreLocal, String nombreCualif, Attributes atr) throws SAXException {
        cadena.setLength(0);
        if (nombreLocal.equals("Row")) {
            numRow++;
            numData=0;
            //Log.d("JCP------", "Inicio Fila "+nombreLocal);
        }
    }
    @Override
    public void characters(char ch[], int comienzo, int lon) {
        cadena.append(ch, comienzo, lon);
    }
    @Override
    public void endElement(String uri, String nombreLocal,
                           String nombreCualif) throws SAXException {
        if (nombreLocal.equals("Data")) {
            //solo trataremos los datos a partir dela fila en la que vienen los datos
            if(numRow>4) {
                //Log.d("JCP------", numRow+"...."+cadena.toString());
                switch (numData){
                    case 0: {arrHora.add(cadena.toString());break;}
                    case 1: {arrTarifaGeneral.add(Double.parseDouble(cadena.toString()));break;}
                    case 2: {arrTarifaNocturna.add(Double.parseDouble(cadena.toString()));break;}
                    case 3: {arrTarifaVehiculo.add(Double.parseDouble(cadena.toString()));break;}
                    default: break;
                }
                numData++;
            }
        }
    }
    @Override
    public void endDocument() throws SAXException {
       // Log.d("JCP------", arrHora.toString());
    }

}
