package com.cfp.jcperez.electricost;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.text.Html;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;

/**
 * Created by Juan Carlos Perez Gonzalez on 10/11/2015.
 * Actividad que nos muestra el mapa con nuestra ubicación y los puntos de recarga
 */

public class MostrarEstacionesActivity extends ActionBarActivity implements GoogleMap.OnMapClickListener, LocationListener {

    //clave
//AIzaSyCtNOuM_XkMnjswYRbhAWEjdj3zyJCFzvU

//mre
//AIzaSyCNoKLbYQKEK0iKNT5qDvmXCKehpq09TuI

        final static String TAG = "JCP----";

        private LocationManager manejador;
        private Location mejorLocaliz;
        public LatLng latUPV = new LatLng(39.46862606, -0.3604187);
        private boolean isFirst=true;
        public ArrayList<Marker> arrMrkMsg = new  ArrayList<Marker>();
        public GoogleMap mapa;
        private Marker marcaPos;
        private ArrayList<Estacion> arrEstaciones = new ArrayList<Estacion>();


        public GoogleMap getMapa() {
            return mapa;
        }
        public Location getMejorLocaliz() {
            return mejorLocaliz;
        }

        @Override
        public void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            setContentView(R.layout.mapaestaciones);
            //Log.d(TAG, "onCreate");
            mapa = ((SupportMapFragment) getSupportFragmentManager()
                    .findFragmentById(R.id.map)).getMap();
            mapa.setMapType(GoogleMap.MAP_TYPE_HYBRID);
            mapa.getUiSettings().setZoomControlsEnabled(false);
            mapa.getUiSettings().setCompassEnabled(true);

            mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(latUPV, 14));

            manejador = (LocationManager) getSystemService(LOCATION_SERVICE);
            if (manejador.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
                actualizaMejorLocaliz(manejador.getLastKnownLocation( LocationManager.GPS_PROVIDER));
            }
            if (manejador.isProviderEnabled(LocationManager.NETWORK_PROVIDER)) {
                actualizaMejorLocaliz(manejador.getLastKnownLocation( LocationManager.NETWORK_PROVIDER));
            }
            new AccesoWeb().execute();
        }

        @Override
        public boolean onCreateOptionsMenu(Menu menu) {
            // Inflate the menu; this adds items to the action bar if it is present.
            getMenuInflater().inflate(R.menu.menu_mapa, menu);
            return true;
        }

    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.acercaDe) {
            lanzarAcercaDe(null);
        }
        if (id == R.id.centrar) {
            if (mejorLocaliz!=null) {
                LatLng latlng = new LatLng(mejorLocaliz.getLatitude(), mejorLocaliz.getLongitude());
                mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(latlng, mapa.getCameraPosition().zoom));
            }
        }
        return super.onOptionsItemSelected(item);
    }

    public void lanzarAcercaDe(View view){
        Intent i = new Intent (this, AcercaDe.class);
        startActivity(i);
    }

        @Override protected void onResume() {
           // Log.d(TAG, "onResume");
            super.onResume();
            activarProveedores();
        }
        private void activarProveedores() {
            if(manejador!=null) {
                Log.d(TAG,""+manejador.isProviderEnabled(LocationManager.NETWORK_PROVIDER));
                if (manejador.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
                    manejador.requestLocationUpdates(LocationManager.GPS_PROVIDER, 10 * 1000, 5, this);
                }
                if (manejador.isProviderEnabled(LocationManager.NETWORK_PROVIDER)) {
                    manejador.requestLocationUpdates(LocationManager.NETWORK_PROVIDER,
                            5 * 1000, 10, this);
                }
            }
        }

        @Override protected void onPause() {
            super.onPause();
            //Log.d(TAG, "onPause");
            manejador.removeUpdates(this);
        }

        @Override public void onLocationChanged(Location location) {
           // Log.d(TAG, "Nueva localizacion: " + location);
            actualizaMejorLocaliz(location);
        }
        @Override public void onProviderDisabled(String proveedor) {
           // Log.d(TAG, "Se deshabilita: "+proveedor);
            activarProveedores();
        }
        @Override public void onProviderEnabled(String proveedor) {
            //Log.d(TAG, "Se habilita: " + proveedor);
            activarProveedores();
        }
        @Override
        public void onStatusChanged(String proveedor, int estado, Bundle extras) {
            //Log.d(TAG, "Cambia estado: " + proveedor);
            activarProveedores();
        }

        private static final long DOS_MINUTOS = 2 * 60 * 1000;
        private void actualizaMejorLocaliz(Location localiz) {
            if (localiz != null && (mejorLocaliz == null
                    || localiz.getAccuracy() < 2*mejorLocaliz.getAccuracy()
                    || localiz.getTime() - mejorLocaliz.getTime() > DOS_MINUTOS)) {
                Log.d(TAG, "Nueva mejor localizacion");
                LatLng latlng = new LatLng(localiz.getLatitude(), localiz.getLongitude());

                if (isFirst) {
                    mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(latlng, mapa.getCameraPosition().zoom));
                    isFirst=false;
                }

                mejorLocaliz = localiz;
                if(marcaPos!=null){
                    marcaPos.remove();
                }
                marcaPos= mapa.addMarker(new MarkerOptions()
                        .position(latlng)
                        .title(getResources().getString(R.string.miubicacion))
                        .anchor(0.5f, 0.5f));
                Log.d(TAG, "latitud:" + localiz.getLatitude());
                Log.d(TAG, "longitud:" + localiz.getLongitude());
            }
        }

        @Override
        public void onMapClick(LatLng puntoPulsado) {
      /*  mapa.addMarker(new MarkerOptions().position(puntoPulsado).
                icon(BitmapDescriptorFactory
                        .defaultMarker(BitmapDescriptorFactory.HUE_YELLOW)));*/
        }

    // Clase que se encarga de obtener los puntos de recarga de la página del ministerio de industria, energia y turismo
    //  www.movele.es
    private class AccesoWeb extends AsyncTask<String, Void, String> {
        private ProgressDialog progreso;
        @Override protected void onPreExecute() {
            progreso = new ProgressDialog(MostrarEstacionesActivity.this);
            progreso.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progreso.setMessage(getResources().getString(R.string.Obteniendodatos));
            progreso.setCancelable(false);
            progreso.show();
        }
        @Override protected String doInBackground(String... param) {
            try {
                ConnectivityManager cm =(ConnectivityManager)getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
                if (cm!=null) {
                    NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
                    if (activeNetwork != null && activeNetwork.isConnected()) {
                        URL url = new URL("http://www.movele.es/index.php/mod.puntos/mem.mapa/relmenu.20/regini.0/numregs.80000");
                        //Log.d(TAG, "URL " + url.toString());
                        HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
                        //Log.d(TAG,"Conexion ");
                        if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                            BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
                            String linea = reader.readLine();
                            boolean isEstacion = false;
                            Estacion est = null;
                            while (linea != null) {
                                if (isEstacion) {
                                    if (linea.contains("<br/>") && !"<br/>".equals(linea)) {
                                        if (est.getDireccion() != null) {
                                            est.setDireccion(linea);
                                            //Log.d(TAG, "Direccion(..." + linea);
                                        } else {
                                            //Log.d(TAG, "Descripcion(..." + linea);
                                            est.setDireccion(linea);
                                        }
                                    }
                                    if (linea.contains("latitud")) {
                                        String lat = linea.substring(linea.indexOf("latitud."));
                                        lat = lat.substring("latitud.".length(), lat.indexOf("/")).replace("%232E%23", ".");
                                        est.setLatitud(Double.parseDouble(lat));
                                    }
                                    if (linea.contains("longitud")) {
                                        String longi = linea.substring(linea.indexOf("longitud."));
                                        longi = longi.substring("longitud.".length(), longi.indexOf("/")).replace("%232E%23", ".");
                                        est.setLongitud(Double.parseDouble(longi));
                                        arrEstaciones.add(est);
                                        isEstacion = false;
                                        est = null;
                                    }
                                }
                                if (linea.contains("document.write('")) {
                                    isEstacion = true;
                                    est = new Estacion();
                                    String desc = linea.substring(linea.indexOf("document.write('"));
                                    desc = desc.substring("document.write('".length(), desc.lastIndexOf("'"));
                                    est.setDescripcion(desc);
                                }
                                linea = reader.readLine();
                            }
                            reader.close();
                        }
                        conexion.disconnect();
                        return "1";
                    }else{
                        return "-2";
                    }
                }else{
                    return "-2";
                }
            }catch (Exception e){
                Log.d("JCP-----", "ERRORRRRRRRRRRR..." + e.toString());
                return null;
            }
        }
        @Override protected void onPostExecute(String res) {
            progreso.dismiss();
            if("-2".equals(res)){
                Toast toast1 =   Toast.makeText(getApplicationContext(),
                        getString(R.string.nohayconexionalared), Toast.LENGTH_LONG);
                toast1.show();
            }else {
                for (int i = 0; i < arrEstaciones.size(); i++) {
                    Estacion est = arrEstaciones.get(i);
                    LatLng latlng = new LatLng(est.getLatitud(), est.getLongitud());
                    Marker marca = mapa.addMarker(new MarkerOptions()
                            .position(latlng)
                            .title(Html.fromHtml(est.getDescripcion()).toString())
                            .snippet(Html.fromHtml(est.getDireccion()).toString())
                            .icon(BitmapDescriptorFactory
                                    .fromResource(R.drawable.battery_charge))
                            .anchor(0.5f, 0.5f));
                }
            }
        }
        @Override protected void onCancelled() {
            progreso.dismiss();
        }
    }
}
