package com.cfp.jcperez.electricost;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * Created by Juan Carlos Perez Gonzalez on 21/10/2015.
 * Se encarga de recibir el inicio del S.O. para planificar a las 23:00 el servicio que se conecta a la web de la REE para
 * obtener los precios y gestionar las notificaciones al usuario
 */
public class ReceptorArranque extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        final AlarmManager alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
        final Calendar cal = Calendar.getInstance();
        //Programamos que se lance a las 23:00 el servicio que recupera los precios de la luz y gestiona las notificaciones
        cal.setTimeInMillis(System.currentTimeMillis());
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        Intent intentForService = new Intent(context.getApplicationContext(), ServicioAlarma.class);
        GregorianCalendar calendarioAviso = new GregorianCalendar();
        calendarioAviso.add(Calendar.DAY_OF_YEAR, 1);
        intentForService.putExtra("Fecha", (new SimpleDateFormat("yyyyMMdd")).format(calendarioAviso.getTime()));
        PendingIntent service = PendingIntent.getService(context, 0, intentForService,    PendingIntent.FLAG_UPDATE_CURRENT);
        alarmManager.setInexactRepeating(AlarmManager.RTC_WAKEUP, cal.getTimeInMillis(), AlarmManager.INTERVAL_DAY, service);
    }
}
