package com.cfp.jcperez.electricost;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.util.Log;
/**
 * Created by Juan Carlos Perez Gonzalez on 21/10/2015.
 * Se encarga de recibir un cambio en la conexion a internet del terminal y en caso de haber pendiente alguna consulta para
 * gestionar las notificaciones al usuario inicia dicho servicio.
 */
public class ReceptorCambioConexion extends BroadcastReceiver {
    String TAG="JCP------";

    @Override
    public void onReceive(Context context, Intent intent) {
        ConnectivityManager cm =(ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
        if (cm!=null) {
            NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
            if (activeNetwork != null && activeNetwork.isConnected()) {
                BBDDReintentos bbdd = new BBDDReintentos(context);
                //insertamos un registro en la tabla de reintentos para que cuando tengamos acceso a la red volvamos a intentar planificar los avisos
                String fecha = bbdd.getReintento();
                if (fecha == null) {
                    Log.d(TAG, "no hay reintentos");
                } else {
                    Log.d(TAG, "reintento" + fecha);
                    Intent intent1 = new Intent(context, ServicioAlarma.class);
                    intent1.putExtra("Fecha", fecha);
                    context.startService(intent1);
                }
            }
        }
    }

}
