package com.cfp.jcperez.electricost;

import android.app.AlarmManager;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.support.v7.app.NotificationCompat;
import android.util.Log;
import android.widget.ListView;
import android.widget.Toast;

import com.jjoe64.graphview.GraphView;
import com.jjoe64.graphview.series.DataPoint;
import com.jjoe64.graphview.series.LineGraphSeries;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * Created by Juan Carlos Perez Gonzalez on 16/11/2015.
 * Accede a la web de la REE, recupera los precios minimos y máximos por tarifa y en función de las
 * preferencias del usuario planifica los servicios para que se lancen las notificaciones a las horas
 * indicadas
 */
public class ServicioAlarma extends Service {

    String TAG="JCP------";

    @Override
    public void onCreate() {
        //Log.d(TAG, "Creado");
    }

    @Override
    public int onStartCommand(Intent intenc, int flags, int idArranque) {
        //Log.d(TAG, "Start");
        String[] param= new String[1];
        param[0]= intenc.getStringExtra("Fecha");
        Log.d(TAG,"fecha "+param[0]);
        new AccesoWebREE().execute(param);
        return START_STICKY;
    }

    @Override public void onDestroy() {
        Log.d(TAG, "Destroy");
    }

    @Override public IBinder onBind(Intent intencion) {
        return null;
    }

    private class AccesoWebREE extends AsyncTask<String, Void, String> {
        private ArrayList<String> arrHoras = new  ArrayList<String>();
        private ArrayList<Double> arrTG = new  ArrayList<Double>();
        private ArrayList<Double> arrTN = new  ArrayList<Double>();
        private ArrayList<Double> arrVE = new  ArrayList<Double>();
        private String fecha;
        @Override protected void onPreExecute() {

        }
        @Override protected String doInBackground(String... param) {
            try {
                //eliminamos los intentos de acceder a los datos pendientes
                BBDDReintentos bbdd = new BBDDReintentos(getApplicationContext());
                bbdd.borrarReintentos();

                //accedemos a los datos de la web
                fecha=param[0];
                URL url = new URL("http://www.esios.ree.es/Solicitar/PVPC_DD_"+param[0]+".xls&es");
                Log.d("JCP-----", "URL " + url.toString());
                HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
                Log.d("JCP-----", "Conexion ");
                if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                    SAXParserFactory fabrica = SAXParserFactory.newInstance();
                    SAXParser parser = fabrica.newSAXParser();
                    XMLReader lector = parser.getXMLReader();
                    ManejadorXMLREE manejadorXMLREE = new ManejadorXMLREE();
                    lector.setContentHandler(manejadorXMLREE);
                    InputSource in = new InputSource(conexion.getInputStream());
                    in.setEncoding("ISO-8859-1");
                    lector.parse(in);
                    arrHoras= manejadorXMLREE.getArrHora();
                    arrTG= manejadorXMLREE.getArrTarifaGeneral();
                    arrTN= manejadorXMLREE.getArrTarifaNocturna();
                    arrVE= manejadorXMLREE.getArrTarifaVehiculo();
                }
                conexion.disconnect();

                if (arrTG==null || arrTG.size()<1){
                    return "-1";
                }else {
                    return "1";
                }
            }catch (Exception e){
                //comprobamos si tenemos conexion a internet
                ConnectivityManager cm =(ConnectivityManager)getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
                if (cm!=null) {
                    NetworkInfo activeNetwork = cm.getActiveNetworkInfo();

                    if (activeNetwork == null || !activeNetwork.isConnected()) {
                        BBDDReintentos bbdd = new BBDDReintentos(getApplicationContext());
                        //borramos los reintentos anteriores
                        bbdd.borrarReintentos();
                        //insertamos un registro en la tabla de reintentos para que cuando tengamos acceso a la red volvamos a intentar planificar los avisos
                        bbdd.guardarReintento(param[0]);
                    }
                }else{
                    BBDDReintentos bbdd = new BBDDReintentos(getApplicationContext());
                    //borramos los reintentos anteriores
                    bbdd.borrarReintentos();
                    //insertamos un registro en la tabla de reintentos para que cuando tengamos acceso a la red volvamos a intentar planificar los avisos
                    bbdd.guardarReintento(param[0]);
                }

                Log.d(TAG, "ERRORRRRRRRRRRR..." + e.toString());
                return "-1";
            }
        }
        @Override protected void onPostExecute(String res) {
            if (!"-1".equals(res)){

                SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
                boolean avisoMaxTG=pref.getBoolean("avisoAltoTG",false);
                boolean avisoMinTG=pref.getBoolean("avisoBajoTG",false);
                boolean avisoMaxTN=pref.getBoolean("avisoAltoTN",false);
                boolean avisoMinTN=pref.getBoolean("avisoBajoTN",false);
                boolean avisoMaxCE=pref.getBoolean("avisoAltoCE",false);
                boolean avisoMinCE=pref.getBoolean("avisoBajoCE",false);

                if (avisoMinTG){
                    int i = arrTG.indexOf(Collections.min(arrTG).doubleValue());
                    Log.d(TAG,getString(R.string.horamenorTG) + arrHoras.get(i));
                    programarAvisoPrecio(getString(R.string.tarifageneral), getString(R.string.masbaratodia), arrHoras.get(i),1);
                }
                if (avisoMinTN){
                    int i = arrTN.indexOf(Collections.min(arrTN).doubleValue());
                    Log.d(TAG,getString(R.string.horamenorTN) + arrHoras.get(i));
                    programarAvisoPrecio(getString(R.string.tarifanocturna), getString(R.string.masbaratodia),  arrHoras.get(i),2);
                }
                if (avisoMinCE){
                    int i = arrVE.indexOf(Collections.min(arrVE).doubleValue());
                    Log.d(TAG,getString(R.string.horamenorVE) + arrHoras.get(i));;
                    programarAvisoPrecio(getString(R.string.CocheElectrico), getString(R.string.masbaratodia),  arrHoras.get(i),3);
                }
                if (avisoMaxTG){
                    int i = arrTG.indexOf(Collections.max(arrTG).doubleValue());
                    Log.d(TAG,getString(R.string.horamayorTG) +arrHoras.get(i));
                    programarAvisoPrecio(getString(R.string.tarifageneral), getString(R.string.mascarodia),  arrHoras.get(i),4);
                }
                if (avisoMaxTN){
                    int i = arrTN.indexOf(Collections.max(arrTN).doubleValue());
                    Log.d(TAG,getString(R.string.horamayorTN) + arrHoras.get(i));
                    programarAvisoPrecio(getString(R.string.tarifanocturna), getString(R.string.mascarodia),  arrHoras.get(i),5);
                }
                if (avisoMaxCE){
                    int i = arrVE.indexOf(Collections.max(arrVE).doubleValue());
                    Log.d(TAG,getString(R.string.horamayorVE) + arrHoras.get(i));
                    programarAvisoPrecio(getString(R.string.CocheElectrico), getString(R.string.mascarodia),  arrHoras.get(i),6);
                }

            }
        }
        @Override protected void onCancelled() {

        }

        private void programarAvisoPrecio(String titulo, String desc,String strHora, int numAlarm) {
            final AlarmManager alarmManager = (AlarmManager) getApplicationContext().getSystemService(Context.ALARM_SERVICE);
            final Calendar cal = Calendar.getInstance();
            cal.setTimeInMillis(System.currentTimeMillis());
            if (strHora.indexOf("-") > -1) {
                strHora = strHora.substring(0, strHora.indexOf("-"));
            }
            cal.setTimeInMillis(System.currentTimeMillis());
            int numHoraIni = Integer.parseInt(strHora);
            cal.set(Calendar.HOUR_OF_DAY, numHoraIni);
            cal.set(Calendar.MINUTE, 0);
            cal.set(Calendar.SECOND, 0);
            cal.set(Calendar.MILLISECOND, 0);

            String fechaAlarm = (new SimpleDateFormat("yyyyMMdd")).format(cal.getTime());
            boolean bProgramarAviso=true;
            if(fechaAlarm.equals(fecha)) {
                if (System.currentTimeMillis() > (cal.getTimeInMillis() + (60 * 60 * 1000))) {
                    //Ha pasado la hora de aviso
                    bProgramarAviso=false;
                }
            }else{
                try {
                    DateFormat sdf = new SimpleDateFormat("yyyyMMdd");
                    Date dateAlarm = sdf.parse(fechaAlarm);
                    Date dateConsulta = sdf.parse(fecha);
                    if (dateAlarm.after(dateConsulta)) {
                        bProgramarAviso = false;
                    }else{
                        cal.add(Calendar.DAY_OF_YEAR,1);
                    }
                }catch(Exception e){
                   Log.d(TAG,"ERROR"+e.getMessage());
                }
            }

            if (bProgramarAviso) {
                Intent intentForService = new Intent(getApplicationContext().getApplicationContext(), ServicioAvisoPrecio.class);
                intentForService.putExtra("Titulo", titulo);
                intentForService.putExtra("Desc", desc + " " + numHoraIni + ":00 - " + (numHoraIni + 1) + ":00");
                PendingIntent service = PendingIntent.getService(getApplicationContext(), numAlarm, intentForService, PendingIntent.FLAG_UPDATE_CURRENT);
                alarmManager.set(AlarmManager.RTC_WAKEUP, cal.getTimeInMillis(), service);
            }
        }
    }



}