package com.cfp.jcperez.electricost;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.support.v7.app.NotificationCompat;
import android.util.Log;
import android.widget.Toast;

/**
 * Created by Juan Carlos Perez Gonzalez on 16/11/2015.
 * Se encarga de mostrar una notificación al usuario para indicarle una alerta de precio más bajo o más alto
 * del día según corresponda
 */
public class ServicioAvisoPrecio extends Service {

    NotificationManager notificationManager;
    String TAG="JCP------";
    @Override
    public void onCreate() {
        //Log.d(TAG, "Creado");
    }

    @Override
    public int onStartCommand(Intent intenc, int flags, int idArranque) {
        //Log.d(TAG, "Start");
        String titulo = intenc.getStringExtra("Titulo");
        String desc = intenc.getStringExtra("Desc");
        NotificationCompat.Builder notific = (NotificationCompat.Builder) new NotificationCompat.Builder(this).setContentTitle(titulo)
                .setSmallIcon(R.drawable.iconotificacion)
                .setDefaults(Notification.DEFAULT_ALL)
                .setContentText(desc);
        notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        Intent i = new Intent(this, MainActivity.class);
        PendingIntent intencionPendiente = PendingIntent.getActivity(this, 0, i, PendingIntent.FLAG_UPDATE_CURRENT);
        notific.setContentIntent(intencionPendiente);
        notificationManager.notify((int) System.currentTimeMillis(), notific.build());
        return START_STICKY;
    }

    @Override public void onDestroy() {
        //Log.d(TAG,"Destroy");

    }

    @Override public IBinder onBind(Intent intencion) {
        return null;
    }

}